<template>
    <div class='mx-6 sm:mx-14'>
        <p class='text-4xl sm:text-5xl font-bold text-xmas-gray sm:text-center'>BGG Профил</p>
        <p class='text-sm mt-10'>Да улесним малко твоя таен Дядо Коледа като любезно му предоставим профила ти в BoardGameGeek™. Дай ни само никнейма, напр. MonopolyGamer</p>
        <p class='text-sm mt-4'>И все пак, ако нямаш такъв можеш да пропуснеш тази стъпка.</p>
        <div class='mt-10 mb-10 space-y-3'>
            <Text v-model="form.bgg" @blur="v$.form.bgg.$touch()" :invalid="v$.form.bgg.$error" label="BGG Профил" required></Text>
            <p v-if='v$.form.bgg.$error' class='text-sm text-xmas-red'>Не намираме BGG профил с това име. Правописна грешка?</p>
        </div>
        <ButtonStack :disabled="v$.$invalid || v$.$pending" @click='advance'></ButtonStack>
    </div>
</template>

<script>
    import Text from '@/components/Text'
    import ButtonStack from '@/components/ButtonStack'
    import useVuelidate from '@vuelidate/core' 
    import { helpers, required, email, minLength, maxLength } from '@vuelidate/validators'

    const validBgg = (value) => !helpers.req(value) || axios.get('api/bgg', {params: encodeURIComponent(value.trim())}).then(r => r.data);
   
    export default {
        name: 'Step 3',
        components: {
            Text,
            ButtonStack
        },
        data() {
            return {
                form: {
                    bgg: '',
                },
            }
        },
        methods: {  
            forward() {
                this.$store.commit('stepForward');
            },
            advance() {
                this.syncWithStore();
                this.$store.dispatch("register/advance")
            },
            syncWithStore() {
                this.$store.state.register.registrationData.bgg = this.form.bgg;
            },
            syncFromStore() {
                this.form.bgg = this.$store.state.register.registrationData.bgg;
            },
        },
        created() {
            this.syncFromStore();
        },
        setup() {
            return { v$: useVuelidate() }
        },
        validations: {
            form: {
                bgg: {
                    validBgg: helpers.withAsync(validBgg)
                },
            }
        }
    }
</script>